#!/usr/bin/perl

#              Brought to you by Enigma Engines for a Better World:
#		 
#Engine_Mail 2.1E  By  Lynn Bry, lynn@pharmdec.wustl.edu 1/96.
#Copyright Lynn Bry 1995, 1996 All rights reserved.
#
#	Address
#		Lynn Bry, MD/PhD Student
#		Washington University Medical School
#		Box 8103
#		660 S. Euclid Ave.
#		St. Louis MO 63110
#		U.S.A.		
#
#       Use of Engine_Mail2.1E is free provided you do not remove
#       these comments, you do not distribute it with any alterations
#       not first approved by me, and that your uses and intentions are
#       educational or not-for-profit. If you plan to use this script in
#       conjunction with a profitable organization, or to your own
#       financial gain, you may do so with a $15 (US) donation to your
#       local public library, or branch of the Red Cross.
#
#               Spread the wealth. Make a small child happy.
#
#	On-line information and help:
#	http://pharmdec.wustl.edu/juju/E.M./engine_mail.html
#
#WHAT'S THE USE OF A MAILING ENGINE?
#
#	Engine_mail will generate on-the-fly email forms for any user
#	specified in the mail_list file. A separate script, do_mail,
#	also available from the site above will create mail_list for you
#	from /etc/passwd.
#
#	The script can be called in one of four ways:
#	    1) Anchored link, no appended data: 
#		<a href="/cgi-bin/engine_mail">Mail Gateway</a>
#	       Pulls up a query form for searching the mail_list.
#	    2) Anchored link, user's name appended:
#		<a href="/cgi-bin/engine_mail?user">User's Mail Page</a>
#              Generates a mail form for 'user'
#	    3) Email button: simple form linking to a user's email page:
#
#	        <FORM METHOD="POST" ACTION="/cgi-bin/engine_mail">
#               <INPUT NAME="switch" VALUE="0" TYPE="hidden">
#       	<INPUT NAME="user" VALUE="user" TYPE="hidden">
#       	<INPUT NAME="url" VALUE="URL/of/current/document" TYPE="hidden">
#	        <INPUT TYPE="submit" VALUE="Email Form">
#       	</FORM> 
#
#		Where 'user' is generally the person's login and 'url' is
#		the URL of the document linking to the script. If you 
#		include the URL, the person sending mail will be able
#		to return to the original page via the script.
#            4) Custom Email forms. Users can write their own email
#               forms and send them to the server. More information on
#               doing this is at the URL specified above.		
#
# FIXES to Version 2.1E
#	Version 2.1E is current as of 1-8-96.
#	2.1E has the following additions over 2.0E:
#	 1) Checks for |<> in submitted name and email address.
#	 2) Automatic link made to document of origin if the
#	    WWW server understands $ENV{'HTTP_REFERER'}
#
###########CHANGE THE VARIABLES BELOW TO SUIT YOUR NEEDS#############

	##SYSTEM AND SERVER DEFINITIONS

#Make sure the first line of this script reflects the
#location of Perl on your system.. #!/usr/bin/perl.. &c..

##Absolute path to the mail_list. Each line has the format: 
##Full Name:user_nickname:mail_address for a single user.
##i.e.    Rrose Selavy:rrose:rrose@bachelors.even.net
$mail_list='/usr/local/www/conf/mail_list';

##Absolute path to sendmail: (-t=To:, -n=No aliasing, -oi=ignore '.' as an
##EOM if on a line by itself.
$sendmail='/usr/lib/sendmail -t -n -oi';

##Path to this script relative to your WWW Server:
$mailing_engine='/cgi-bin/engine_mail';

##Name of your WWW Server: 
$site='Rroses Web';

##Name or account of Webmaster, Webmadame or Webmaestro...
$www_admin='Webmadame';

##Above's email, in the event of error messages.
$www_admin_email='rrose@bachelors.even.net';

	##LOGGING AND SEARCH PARAMETERS
##If uncommented, Perl regular expressions will be escaped in any
##query submitted through the search form (?+./\^ etc..).
$no_regexp_allowed=1;

##The maximum number of hits to be returned after a search. 
$max_total=20;

##Uncomment $logging and $mail_log to log all mail sent through the script. 
##The log records the IP# of the sender's browser, their supposed name,
##email, the date and the recipient of the message.
#$logging=1;

##Absolute path to the mail_log. This file must be 'world' writable.
#$mail_log='/usr/local/www/logs/mail_log';

##Trailer to appear at the bottom of returned HTML output:
##Place any text/html between the ADDRESS tags.
$trailer='<HR>
<ADDRESS>
<a href="http://pharmdec.wustl.edu/juju/E.M./engine_mail.html">
Engine Mail, Version 2.1E</a>
</ADDRESS>'; 

###########################Bon appetit###############################
##########You shouldn't need to change anything else#################

#get the login of the web admin from the address in $www_admin_email.

($www_login, $www_addr)=split(/@/, $www_admin_email);

#####################################################################
#       	Two moments of explanation for the curious..
#
# Two things control the behaviour of the script, the METHOD used
# to send information to it (GET or POST), and the value of the
# variable $switch. $ENV{'REQUEST_METHOD'} has precedence.. if GET,
# the request comes from an anchored link <a href... Output will be 
# either a query form if no info is appended to the url
# ($ENV{'QUERY_STRING'}), or the mail form for the user in QUERY_STRING.
#
# For POST the script assesses the value of $switch.
# $switch<1 => A call from an 'email button'; output a mail_form. 
# $switch=1 => A filled out mail form, send the message, etc..
# $switch>1 => A query submitted though the search form. Run the
# search and output the results.
# $switch is adjusted accordingly in the output of any HTML FORM.
#####################################################################


#####################################################################
#PROCESS INFORMATION SENT TO THE SCRIPT, BASED ON THE REQUEST_METHOD#
#####################################################################

if ($ENV{'REQUEST_METHOD'} eq "GET"){
#Define the script $switch automatically for the output HTML form.
	$switch=0; #Output will be a mail or query form.

#
# Generate a URL from $ENV{'HTTP_REFERER'}
#
	$path=$ENV{'HTTP_REFERER'};
        $url="<a href=\"$path\">Return to the original page.</a>\n"; 

#
# Read data appended to the URL..
#
	$user=$ENV{'QUERY_STRING'};
	$user=&escape_exp($user) if($no_regexp_allowed);

	if ($user eq ""){
		&query_form;
		exit;
	}
#
# Check that $user is in the mail_list; get their full name and email.
#
	($person, $recipient)=&check_valid_user($user);
	if($person eq "" || $recipient eq ""){
		&not_on_system;
	}
	else{
		&remove_escapes($user,$person,$recipient);	
		&mail_form;
	}
}#END OF GET


elsif ($ENV{'REQUEST_METHOD'} eq "POST"){
#Read the incoming information into $request. Send it to &url_decode
#to be decoded into the associative array %rapairs.


        read(STDIN, $request, $ENV{'CONTENT_LENGTH'});
        %rqpairs = &url_decode(split(/[&=]/, $request));

#
#Move values in %rqpairs into single vars.
#
	$query=$rqpairs{'query'};
	$user=$rqpairs{'user'};
	if($no_regexp_allowed){
		$query=&escape_exp($query) if ($query ne "");
		$user=&escape_exp($user) if ($user ne "");
	}

	$switch=$rqpairs{'switch'};

	$path=$rqpairs{'url'};
	if($path ne ""){#If $path has something in it..
		$url="<a href=\"$path\">Return to the original page.</a>";
	}
#
#If no user or query is specified, send a query_form.
#
        &query_form if($user eq "" && $query eq "");

#
#If $switch>1, input comes from the query form; run the search..
#
	if($switch>1){
		open(LISTINGS, "$mail_list") || die "Can't open
mail_list! $!\n";
		while(<LISTINGS>){
			chop;
			@check=split(/@/); #Make sure we don't match	
					   #to the site address..
		        if($check[0]=~/$query/i){
		       	       	$match[$i]=$_;
		                $i++;
			}
	        }
		&remove_escapes($query);	

#
#Send output based on the number of matches to the query.
#
		if(($total=@match)>$max_total){
			&too_many_html;
		}
		elsif($total>1 && $total<$max_total){
			&many_match_html;
		}
		elsif($total<1){
			&no_match_html;
		}
#
#If only one user matched, send their mail_form as output.
#Split the line of info info into $person, $user, $recipient
#remove any \ from escaped characters (*&.. etc).
#
		else{
			($person,$user,$recipient)=split(/:/, $match[0]);
			&remove_escapes($person,$user,$recipient);
			&mail_form;
		}
	}
#
# $switch<1 => an email button asking for the email form for $user.
#
	elsif($switch<1){
	        ($person, $recipient)=&check_valid_user($user);
		&remove_escapes($person,$user,$recipient);
        	if($person eq "" || $recipient eq ""){
                	&not_on_system;
        	}
        	else{
                        &mail_form;
        	}
	}
#
# $switch=1 => a filed out email form. Run the necessary checks, send
# mail and log the transaction.
#
	else{ 
        	($person, $recipient)=&check_valid_user($user);
        	if($person eq "" || $recipient eq ""){
                        &not_on_system;
                }
		else{
	        #Send the message, and return HTML page to the user.
			&check_mail_info;
        		&send_mail || die "$@\n";
			&log if ($logging);
        		&html_output;
		}
	}
}

#
#If we get to this point, $ENV{'REQUEST_METHOD'} was not GET or POST.
#
else{
        &method_not_supported;
} 

exit;

##############THAT'S ALLE FOLKES###############
##########Except for the SUBROUTINES###########

sub url_decode {

    foreach (@_) {
        tr/+/ /;
        s/%(..)/pack("c",hex($1))/ge;
    }
    @_;
}


sub escape_exp{

	$_=$_[0];

	s/\*/\\*/g;
	s/\?/\\?/g;
	s/\^/\\^/g;
	s/\+/\\+/g;

$_;
}

sub remove_escapes{

	foreach (@_){
		s/\\//g;
	}

@_;
}


sub check_valid_user{
#Look for $user in the mail_list file, path defined in $mail_list.

	open(LISTINGS, "$mail_list") || die "Can't open mail_list file!";
	while(<LISTINGS>){#Search for the user.
		chop;
	        if(/$user/){#We may have a match..
	       	 	@possible=split(/:/);#Take a closer look..
       		        if($user eq "$possible[1]"){#Found 'em..
               	         	last;
		        }
         	}
	}
($possible[0], $possible[2]); #Return full name and email address.
}


sub query_form{
##If there's no query appended to the URL, send a query form as output.

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Mailing Engine for $site</TITLE>
<H2>$site Mailing Engine</H2>
<HR>
Enter your query in the space below. If you don't know the full
name of the person, try their first, last, or suspected login name.
Searching is case-insensitive. Press the 'Submit' button to begin
the search.
<P>
<FORM METHOD="post" ACTION="$mailing_engine">
<PRE><B>Query:</B> <INPUT NAME="query" SIZE=14>
<INPUT NAME="switch" VALUE="2" TYPE="hidden">
<INPUT NAME="url" VALUE="$path" TYPE="hidden">
<INPUT TYPE = "submit" VALUE = "Submit"></PRE>
</FORM>
<P>
$trailer
END_OF_HTML

exit;
}

sub mail_form{
#If we have info, but $switch=0; the browser needs a mail form..


print <<END_OF_HTML;
Content-type:text/html

<TITLE>Email form for $person</TITLE>
<H2>Send Email to $person</H2>
<HR>
This is an email form. If your browser does not support forms please
send email to $person at <a href="mailto:$recipient">$recipient</a>.
<P>
Please enter your message in the areas provided below. Be sure to
fill out all of the fields.
<HR>
<FORM METHOD="POST" ACTION="$mailing_engine">
Your Name: <INPUT NAME="name" size=20><br>
Email Address: <INPUT NAME="reply_to"size=30><br>
Subject: <INPUT NAME="subject" size=40>
<INPUT NAME="user" VALUE="$user" TYPE="hidden">
<INPUT NAME="switch" VALUE="1" TYPE="hidden">
<INPUT NAME="url" VALUE="$path" TYPE="hidden">
<P>
Enter your message in the space below:<br>
<TEXTAREA NAME="message" ROWS=6 COLS=60></TEXTAREA> <P>
Click <INPUT TYPE="submit" VALUE="submit"> to submit your
message. Click <INPUT TYPE="reset" VALUE="reset"> to clear
your message and start over.
</FORM>
<HR>
<P>
$url
<P>
$trailer
END_OF_HTML

exit;
}

sub not_on_system{
##If the user name matched, but did not pull up a corresponding
##recipient or email address, send not_on_system as output.

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Error: Unacceptable User</TITLE>
<H2>User name $user not accepted.</H2>
<HR>
That user was not found on this system. If you believe this
message to be in err, please contact the system administrator at <a href=
"mailto:$www_admin">$www_admin_email</a>.
        <FORM METHOD="post" ACTION="$mailing_engine">
        <INPUT NAME="user" VALUE="$www_login" TYPE="hidden">
        <INPUT NAME="switch" VALUE="0" TYPE="hidden">
        <INPUT TYPE="submit" VALUE="Admin Email">
        </FORM>
<P>
$url
<P>
$trailer
END_OF_HTML

exit;
}



sub check_mail_info{
#Read the appropriate information from %rqpairs, and make sure the
#$name and $message fields have been filled out, and that no illegal
#characters are found in the $name ($,&,(,)) or $reply_to fields.

	$name=$rqpairs{'name'};
	$reply_to=$rqpairs{'reply_to'};
	$subject=$rqpairs{'subject'};
	$message=$rqpairs{'message'};

	$reply_to='No email address given.' if($reply_to eq "");
	$subject='No subject' if($subject eq "");

	&blank_fields if($name eq "" || $message eq "");
	&illegal_chars('name', $name) if($name =~ /[\$&()|<>]/);
	&illegal_chars('email', $reply_to) if($reply_to =~ /[\$&()|<>]/);

1;
}


sub blank_fields{

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Error!</TITLE>
<H2>Error: Fields not filled out!</H2>
<HR>
<P>
Please make sure to enter at least your name and message on the
email form.
<P>
<FORM METHOD="post" ACTION="$mailing_engine">
<INPUT NAME="user" VALUE="$user" TYPE="hidden">
<INPUT NAME="switch" VALUE="0" TYPE="hidden">
<INPUT NAME="url" VALUE="$path" TYPE="hidden">
<INPUT TYPE="submit" VALUE="Try it again..">
</FORM>
$trailer

END_OF_HTML

exit;
}


sub send_mail{
##Determine the address of the sender's browser.

$realfrom = $ENV{'REMOTE_HOST'} ? $ENV{'REMOTE_HOST'}: $ENV{'REMOTE_ADDR'};

#Preferatory message at top of the email stating the sender and their
#email address have not been confirmed.
#

$warning="[Please note, sender's name and email have not been confirmed for validity.]";

open(MAIL, "|$sendmail") || die "Cannot open sendmail! $@";

print MAIL <<END_OF_MESSAGE;
From: $reply_to ($name) 
To: $recipient
Reply-To: $reply_to
Errors-To: $recipient
Sender: $name  
Subject: $subject
X-Mail-Gateway: Engine_Mail2.1E ($site)
X-Real-Host_From: $realfrom

$warning

$message

END_OF_MESSAGE
}


sub log{

$Date=localtime(time);

open (LOG, ">>$mail_log") || warn "Cannot open mail log! $!\n";
print LOG "$Date: $name at $reply_to (IP:$realfrom) sending mail to $recipient.\n"; 
}

sub html_output{
##Output to satisfy the user that their mail has been sent..

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Mail Sent!</TITLE>
<H2>Mail Sent!</H2>
<HR>
<STRONG>Your message has been sent to $person.</STRONG>
<P>
Here is the body of your message:
<P>
<B>From:</B> $reply_to ($name)<BR>
<B>To:</B> $recipient<BR>
<B>Reply-To:</B> $reply_to<BR>
<B>Errors-To:</B> $recipient<BR>
<B>Sender:</B> $name<BR>
<B>Subject:</B> $subject<BR>
<B>X-Mail-Gateway:</B> $site Mailing Engine<BR>
<B>X-Real-Host_From:</B> $realfrom<BR>
<P><PRE>
$message
</PRE><P>
<HR>
<P>
$url
<P>
$trailer
END_OF_HTML
exit;
} 

sub no_match_html{

print <<END_OF_HTML;
Content-type:text/html

<TITLE>No Matches Found</TITLE>
<H2>No matches found to your query.</H2>
<HR>
<STRONG>$query</STRONG> did not match the names of any users on
this system.
<P>
<a href="$mailing_engine">Please try another query.</a>
<P>
$trailer
END_OF_HTML

exit;
}

sub too_many_html{

print <<END_OF_HTML;
Content-type:text/html

<TITLE>$total Matches to Query</TITLE>
<H2>Please re-enter query.</H2>
<HR>
Your entry matched $total users on the system. Please choose
a more specific query.
<P>
<a href="$mailing_engine?url=$path">Return to Email Search Form</a>
<P>
$trailer
END_OF_HTML

exit;
}

sub make_email_buttons{

	while($j<$total){
        	@info=split(/:/, $match[$j]);
$choice[$j]="<FORM METHOD=\"POST\" ACTION=\"$mailing_engine\">
<INPUT NAME=\"user\" VALUE=\"$info[1]\" TYPE=\"hidden\">
<INPUT NAME=\"url\" VALUE=\"$path\" TYPE=\"hidden\">
<INPUT NAME=\"switch\" VALUE=\"0\" TYPE=\"hidden\">
<INPUT TYPE=\"submit\" VALUE=\"$info[0] ($info[1])\">
</FORM><p>";
	        $j++;
        }

@choice;
}

sub many_match_html{

@user_buttons=&make_email_buttons;

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Mailing Engine Anteroom</TITLE>
<H2>Multiple matches found to your query..</H2>
<HR>
Your query matched more than one possible user on the system.
Please select the specific user to whom you would like to send email.
<P>
@user_buttons
<P>
$trailer
END_OF_HTML

exit;
} 

sub illegal_chars{

print <<END_OF_HTML;
Content-type:text/html

<TITLE>Error: Illegal Characters!</TITLE>
<H2>
The entry for your $_[0] ($_[1]) contains illegal characters. Please re-enter it.
</H2>
<P>
$url
<P>
$trailer
END_OF_HTML

exit;
}

sub method_not_supported{
	$method=$ENV{'REQUEST_METHOD'};
	$method="(No method specified)" if($method eq "");

print <<END_OF_HTML;
Content-type:text/html

Engine_Mail does not support METHOD = $method.

END_OF_HTML

exit;
}
